(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common/http')) :
  typeof define === 'function' && define.amd ? define('cgst-lib-angular', ['exports', '@angular/core', '@angular/common/http'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['cgst-lib-angular'] = {}, global.ng.core, global.ng.common.http));
}(this, (function (exports, core, http) { 'use strict';

  exports.CgstLibAngularComponent = /** @class */ (function () {
      function CgstLibAngularComponent() {
      }
      CgstLibAngularComponent.prototype.ngOnInit = function () {
      };
      return CgstLibAngularComponent;
  }());
  exports.CgstLibAngularComponent.decorators = [
      { type: core.Component, args: [{
                  selector: 'cgst-lib-angular',
                  template: "\n    <p>\n      cgst-lib-angular works!\n    </p>\n  "
              },] }
  ];
  exports.CgstLibAngularComponent.ctorParameters = function () { return []; };
  (function (CgstLibAngularComponent) {
      var HttpReQuestModule = /** @class */ (function () {
          function HttpReQuestModule(http) {
              this.http = http;
          }
          HttpReQuestModule.prototype.ngOnInit = function () {
          };
          // Purpose:
          // To create Http Requests (Post, Get, Put, Delete) to backend server
          // Input parameter:
          // url: URL of the request
          // data: The data to pass in the request body; in JSON format
          // token: The token required for authentication
          // Output:
          // Data in JSON format if succeed; or an error message in string if failed
          HttpReQuestModule.prototype.post = function (url, endPoints, data, token) {
              var myHttpHeaders = new http.HttpHeaders({
                  'Content-Type': 'application/json',
                  'Authorization': 'Bearer ' + token,
              });
              var myHttpOptions = { headers: myHttpHeaders };
              var URL = url + endPoints;
              return this.http.post(URL, data, myHttpOptions);
              // Interceptor to handle error message
              // .pipe(
              //   catchError(this.handleError),
              //   tap(resData => {
              //       resData['msg'];
              //   })
              // );
          };
          HttpReQuestModule.prototype.put = function (url, endPoints, data, token) {
              var myHttpHeaders = new http.HttpHeaders({
                  'Content-Type': 'application/json',
                  'Authorization': 'Bearer ' + token,
              });
              var myHttpOptions = { headers: myHttpHeaders };
              var URL = url + endPoints;
              return this.http.put(URL, data, myHttpOptions);
              // Interceptor to handle error message
              // .pipe(
              //   catchError(this.handleError),
              //   tap(resData => {
              //       resData['msg'];
              //   })
              // );
          };
          HttpReQuestModule.prototype.get = function (url, endPoints, data, token) {
              var myHttpHeaders = new http.HttpHeaders({
                  'Content-Type': 'raw',
                  // 'Content-Type': 'application/json',
                  'Authorization': 'Bearer ' + token,
              });
              var URL = url + endPoints;
              // let myParams = JSON.stringify(encodeURI(new URLSearchParams(data2).toString()));
              // let myParams = decodeURI(JSON.stringify(data2))
              // let myParams = Object.keys(data).map(k => `${encodeURIComponent(k)}=${encodeURIComponent(data[k])}`).join('&');
              // let myParams = new HttpParams();
              // myParams = myParams.append("no", "12");
              // myParams = myParams.append("location_region", "C");
              // myParams = myParams.append("location_block", "5");
              // myParams = myParams.append("location_column", "4");
              // myParams = myParams.append("location_row", "5");
              // myParams = myParams.append("size", "S");
              // myParams = myParams.append("status", "A");
              // myParams = myParams.append("remark", "active lu");
              // myParams = myParams.append("created_by", "Eric.INITIAL.DATA");
              // myParams = myParams.append("created_timestamp", "2021-03-30 16:00:34.346864");
              // myParams = myParams.append("last_updated_by", "Eric.INITIAL.DATA");
              // myParams = myParams.append("last_updated_timestamp", "2021-03-30 16:00:34.346864");
              // const myParams: HttpParams = new HttpParams({
              //   fromObject: { 
              //     // 'no': String(studentId),
              //     data,
              //   }
              // });
              return this.http.get(URL, {
                  headers: myHttpHeaders,
                  params: data
              });
              // Interceptor to handle error message
              // .pipe(
              //   catchError(this.handleError),
              //   tap(resData => {
              //     console.log(resData['msg'])
              //   })
              // );
          };
          HttpReQuestModule.prototype.delete = function (url, endPoints, data, token) {
              var myHttpHeaders = new http.HttpHeaders({
                  'Content-Type': 'raw/json',
                  // 'Content-Type': 'application/json',
                  'Authorization': 'Bearer ' + token,
              });
              var URL = url + endPoints;
              return this.http.delete(URL, {
                  headers: myHttpHeaders,
                  params: data
              });
              // Interceptor to handle error message
              // .pipe(
              //   catchError(this.handleError),
              //   tap(resData => {
              //     console.log(resData['msg'])
              //   })
              // );
          };
          return HttpReQuestModule;
      }());
      HttpReQuestModule.decorators = [
          { type: core.Injectable }
      ];
      HttpReQuestModule.ctorParameters = function () { return [
          { type: http.HttpClient }
      ]; };
      CgstLibAngularComponent.HttpReQuestModule = HttpReQuestModule;
      var ValidationModule = /** @class */ (function () {
          function ValidationModule() {
          }
          ValidationModule.prototype.validate_email = function (input) {
              if (/^[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+@[a-zA-Z0-9-]+(?:\.[a-zA-Z0-9-]+)*$/.test(input)) {
                  return (true);
              }
              return (false);
          };
          return ValidationModule;
      }());
      ValidationModule.decorators = [
          { type: core.Injectable }
      ];
      CgstLibAngularComponent.ValidationModule = ValidationModule;
  })(exports.CgstLibAngularComponent || (exports.CgstLibAngularComponent = {}));

  var CgstLibAngularModule = /** @class */ (function () {
      function CgstLibAngularModule() {
      }
      return CgstLibAngularModule;
  }());
  CgstLibAngularModule.decorators = [
      { type: core.NgModule, args: [{
                  declarations: [
                      exports.CgstLibAngularComponent
                  ],
                  imports: [],
                  exports: [
                      exports.CgstLibAngularComponent
                  ]
              },] }
  ];

  /*
   * Public API Surface of cgst-lib-angular
   */

  /**
   * Generated bundle index. Do not edit.
   */

  exports.CgstLibAngularModule = CgstLibAngularModule;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=cgst-lib-angular.umd.js.map
